using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

namespace csharpgui
{
	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class Form2 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form2()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			DataSet data = new DataSet();
			DataTable parent = data.Tables.Add("parent");
			DataTable child = data.Tables.Add("child");

			child.Columns.Add("common");
			child.Columns.Add("parentColumn");
			parent.Columns.Add("common");
			parent.Columns.Add("childColumn");

			data.Relations.Add(parent.Columns["common"], child.Columns["common"]);
			parent.LoadDataRow(new object[]{"c1","1"}, true);
			parent.LoadDataRow(new object[]{"c2","2"}, true);
			parent.LoadDataRow(new object[]{"c3","3"}, true);
			parent.LoadDataRow(new object[]{"c4","4"}, true);
			parent.LoadDataRow(new object[]{"a1","5"}, true);
			parent.LoadDataRow(new object[]{"a2","6"}, true);
			parent.LoadDataRow(new object[]{"a3","7"}, true);
			parent.LoadDataRow(new object[]{"a4","8"}, true);
			child.LoadDataRow(new object[]{"c1","9"}, true);
			child.LoadDataRow(new object[]{"c2","10"}, true);
			child.LoadDataRow(new object[]{"c3","11"}, true);
			child.LoadDataRow(new object[]{"c4","12"}, true);
			child.LoadDataRow(new object[]{"a1","13"}, true);
			child.LoadDataRow(new object[]{"a2","14"}, true);
			child.LoadDataRow(new object[]{"a3","15"}, true);
			child.LoadDataRow(new object[]{"a4","16"}, true);

			this.mainGrid.DataSource = parent;

		}
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl mainGrid;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.mainGrid = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.mainGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(24, 32);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// mainGrid
			// 
			this.mainGrid.Appearance.AlternateRecordFieldCell.AutoSize = true;
			this.mainGrid.Appearance.AlternateRecordFieldCell.CellType = "Static";
			this.mainGrid.Appearance.AlternateRecordFieldCell.ReadOnly = true;
			this.mainGrid.Appearance.RecordFieldCell.AutoSize = true;
			this.mainGrid.Appearance.RecordFieldCell.CellType = "Static";
			this.mainGrid.Appearance.RecordFieldCell.ReadOnly = true;
			this.mainGrid.BackColor = System.Drawing.SystemColors.Window;
			this.mainGrid.Location = new System.Drawing.Point(24, 168);
			this.mainGrid.Name = "mainGrid";
			this.mainGrid.NestedTableGroupOptions.ShowCaption = false;
			this.mainGrid.NestedTableGroupOptions.ShowColumnHeaders = true;
			this.mainGrid.Size = new System.Drawing.Size(600, 264);
			this.mainGrid.TabIndex = 0;
			this.mainGrid.TableOptions.ShowRowHeader = false;
			this.mainGrid.Text = "mainGrid";
			this.mainGrid.TopLevelGroupOptions.ShowCaption = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(168, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Filter on the \"common\" column";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(32, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(488, 88);
			this.label2.TabIndex = 2;
			this.label2.Text = "Steps to reproduce:\n1-Expand row c2 and click on the child row\n2- Type 3 in the f" +
				"ilter section, which will filter out the selected row\n3- Expand one of the remai" +
				"ning rows\n4- Click on the child row -> An exception is thrown here";
			// 
			// Form2
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(648, 454);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.mainGrid);
			this.Name = "Form2";
			this.Text = "Form2";
			((System.ComponentModel.ISupportInitialize)(this.mainGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args_) 
		{
			Form2 f = new Form2();
			f.ShowDialog();            
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			DataView view = (this.mainGrid.DataSource as DataTable).DefaultView;
			if(this.textBox1.Text == "")
			{
				view.RowFilter = "";
			}
			else
			{
				view.RowFilter = string.Format("[common] like '%{0}%'", this.textBox1.Text);
			}
		}
	}
}
